<?php
/*
Plugin Name: WordPress SEO Pager
Plugin URI: http://www.seoegghead.com/software/wordpress-seo-pager.seo
Description: An SEO-enhanced pagination control for WordPress.
Author: SEO Egghead, Inc.
Version: 10.0
Author URI: http://www.seoegghead.com/
*/

	
// Default options

$kanso_sd_pre = '&laquo; '.__('Previous Page','satori');
$kanso_sd_nxt = __('Next Page','satori').' &raquo;';

add_option('SEOPager_styles', 'boxed');
add_option('SEOPager_prelabel', 'pre');
add_option('SEOPager_nextlabel', 'nxt');
add_option('SEOPager_preallow', 'disallow');
add_option('SEOPager_nextallow', 'disallow');
add_option('SEOPager_linkallow', 'allow');
add_option('SEOPager_bordercolor', 'black');
add_option('SEOPager_bgcolor1', 'white');
add_option('SEOPager_bgcolor2', 'white');
add_option('SEOPager_fgcolor1', '#67A7C4');
add_option('SEOPager_fgcolor2', '#7F7F7F');
add_option('SEOPager_auto', 'allow');
add_option('SEOPager_title', 'disallow');
add_option('SEOPager_titletext', '%wp_title% &mdash; Page %page_no%');
add_option('SEOPager_excerpt', 'disallow');
add_option('SEOPager_excerpt_pre', 'Archived; click post to view.<br />
<b>Excerpt:</b>');
add_option('SEOPager_excerpt_post', '...');
add_option('SEOPager_excerpt_length', '25%');
add_option('SEOPager_excerpt_first_page', 'allow');
add_option('SEOPager_ellipsis', '...');
add_option('SEOPager_num_of_pages', '10');


// Add pager to loop_end for automatic pager option

function kanso_sd_pager_hook(){
	if (!is_feed() && !is_admin()) kanso_sd_SEO_pager();
}

function kanso_sd_pager_portfolio_hook(){
	if (!is_feed() && !is_admin()) kanso_sd_SEO_portfolio_pager();
}


// Generates Pager for blog.
function kanso_sd_SEO_pager($seperator = '', $after_previous = '', 
$before_next = '', $prelabel='&laquo; Previous Page', 
$nxtlabel= 'Next Page &raquo;', $ellipsis_text_left = '...', 
$ellipsis_text_right = '...')
{	
		
	global $posts_per_page, $paged, $wp_query;
	$pager_date_format = get_option('date_format');
	
	if(get_option('SEOPager_prelabel') != ''){
		$prelabel = '&laquo; '.__('Previous Page','satori');
	}
	if(get_option('SEOPager_nextlabel') != ''){
		$nxtlabel = __('Next Page','satori').' &raquo;';
	}

	$ellipsis_text_left = $ellipsis_text_right = get_option('SEOPager_ellipsis');
	
	$numposts = $wp_query->found_posts;
	$max_num_pages = ceil($numposts / $posts_per_page);

	$num_begin = 2;
	$num_end = 2;
	$center = get_option('SEOPager_num_of_pages');	
	$pages_in_center = get_option('SEOPager_num_of_pages');
	
	if($paged ==''){
		$paged = 1;
	}
	
	if(is_category()){
 		$catid = get_query_var('cat');
		$p = get_posts("numberposts=300&category=$catid"); 
		$p = query_posts("showposts=-1&cat=$catid"); 
	} else if(is_archive()){
		$monthnum = get_the_time('m');
		$year = get_the_time('Y');
		$p = query_posts("showposts=-1&year=$year&monthnum=$monthnum"); 
	} else{
		$p = query_posts("showposts=-1");
	}
	
	$current_page = $paged;
	list($start,$end) = kanso_sd_get_begin_and_end($current_page, $max_num_pages, $center, 
	$pages_in_center, $num_begin, $num_end);
	
		
	if ($max_num_pages > 1) {

		echo '<div class="pagerbox">';			
		
		if($current_page == 1 ){
			if(get_option('SEOPager_preallow') == 'allow' && $max_num_pages > 1){
				echo '<span class="current" href="" > ' . $prelabel . '</span>';
				echo  $after_previous;
			}
		} else{
			$title = 'title="' . ($current_page-1) . '"';
			echo '<a '.$title.' href="'.get_pagenum_link(($current_page - 1))
			.'" >'.$prelabel . '</a>';
			echo  $after_previous;
		}
		
		if($start > $num_begin){
			for ($cnt = 1; $cnt <=  $num_begin; $cnt++) {
					$begin_link = ''; $end_link = '';
				$title = 'title="' .$cnt  . '"';
				$x[] =  '<a ' . $title . ' href="' . get_pagenum_link($cnt) 
				. '" >' . $cnt . '</a>';
			}
			if(($start - 1)  != $num_begin)
				$x[] = $ellipsis_text_left;
		}	
		
		for ($cnt = $start; $cnt <= $end; $cnt++) {
			if ( $current_page == $cnt) {
				$class = '  class="current">';
				$x[] = '<a class="current">' . $cnt . '</a>';	

			} else {
				$title = 'title="' .$cnt  . '"';
				$x[] = '<a ' . $title . ' href="' . 
				get_pagenum_link($cnt) . '"  >'. $cnt . '</a>';
			}
			
		}
		if($end < ($max_num_pages - $num_end ) ){
			
			$x[] = $ellipsis_text_right ;
			
			for ($cnt =($max_num_pages - $num_end)+1; $cnt <= $max_num_pages; $cnt++){
				$title = 'title="' .$cnt . '"';
				$x[] = '<a ' . $title . 'href="' . get_pagenum_link($cnt) . 
				'"  >'. $cnt . '</a>' . $end_link;
			}
		}
		
		echo join($seperator, $x);

		echo $before_next;
		
		if( $current_page == $max_num_pages){
			if(get_option('SEOPager_nextallow') == 'allow'){
				echo '<span class="current"' .'" > ' . $nxtlabel . '</span>';
			}
		} else{
			$title = 'title="' .($current_page+1) . '"';			
			echo '<a ' . $title .  ' href="' . 
			get_pagenum_link(($current_page + 1))  .'" > ' . $nxtlabel . '</a>';
		}
		echo '</div>';
	} else {
		echo '<div class="pager-empty"></div>';	
	}
}

// Generates Pager for portfolio.
function kanso_sd_SEO_portfolio_pager($seperator = '', $after_previous = '', 
$before_next = '', $prelabel='&laquo; Previous Page', 
$nxtlabel= 'Next Page &raquo;', $ellipsis_text_left = '...', 
$ellipsis_text_right = '...')
{	
		
	global $paged, $wp_query;
	if (function_exists('kanso_sd_get_option_tree') && is_string (kanso_sd_get_option_tree('ppp') ) ) { 
		$posts_per_page = kanso_sd_get_option_tree('ppp') ; 
	} else {
		$posts_per_page = 20;
	}
	$pager_date_format = get_option('date_format');
	
	if(get_option('SEOPager_prelabel') != ''){
		$prelabel = '&laquo; '.__('Previous Page','satori');
	}
	if(get_option('SEOPager_nextlabel') != ''){
		$nxtlabel = __('Next Page','satori').' &raquo;';
	}

	$ellipsis_text_left = $ellipsis_text_right = get_option('SEOPager_ellipsis');
	
	$numposts = $wp_query->found_posts;
	$max_num_pages = ceil($numposts / $posts_per_page);

	$num_begin = 2;
	$num_end = 2;
	$center = get_option('SEOPager_num_of_pages');	
	$pages_in_center = get_option('SEOPager_num_of_pages');
	
	if($paged ==''){
		$paged = 1;
	}
	
	if(is_category()){
 		$catid = get_query_var('cat');
		$p = get_posts("numberposts=300&category=$catid"); 
		$p = query_posts("showposts=-1&cat=$catid"); 
	} else if(is_archive()){
		$monthnum = get_the_time('m');
		$year = get_the_time('Y');
		$p = query_posts("showposts=-1&year=$year&monthnum=$monthnum"); 
	} else{
		$p = query_posts("showposts=-1");
	}
	
	$current_page = $paged;
	list($start,$end) = kanso_sd_get_begin_and_end($current_page, $max_num_pages, $center, 
	$pages_in_center, $num_begin, $num_end);
	
		
	if ($max_num_pages > 1) {

		echo '<div class="pagerbox">';			
		
		if($current_page == 1 ){
			if(get_option('SEOPager_preallow') == 'allow' && $max_num_pages > 1){
				echo '<span class="current" href="" > ' . $prelabel . '</span>';
				echo  $after_previous;
			}
		} else{
			$title = 'title="' . ($current_page-1) . '"';
			echo '<a '.$title.' href="'.get_pagenum_link(($current_page - 1))
			.'" >'.$prelabel . '</a>';
			echo  $after_previous;
		}
		
		if($start > $num_begin){
			for ($cnt = 1; $cnt <=  $num_begin; $cnt++) {
					$begin_link = ''; $end_link = '';
				$title = 'title="' .$cnt  . '"';
				$x[] =  '<a ' . $title . ' href="' . get_pagenum_link($cnt) 
				. '" >' . $cnt . '</a>';
			}
			if(($start - 1)  != $num_begin)
				$x[] = $ellipsis_text_left;
		}	
		
		for ($cnt = $start; $cnt <= $end; $cnt++) {
			if ( $current_page == $cnt) {
				$class = '  class="current">';
				$x[] = '<a class="current">' . $cnt . '</a>';	

			} else {
				$title = 'title="' .$cnt  . '"';
				$x[] = '<a ' . $title . ' href="' . 
				get_pagenum_link($cnt) . '"  >'. $cnt . '</a>';
			}
			
		}
		if($end < ($max_num_pages - $num_end ) ){
			
			$x[] = $ellipsis_text_right ;
			
			for ($cnt =($max_num_pages - $num_end)+1; $cnt <= $max_num_pages; $cnt++){
				$title = 'title="' .$cnt . '"';
				$x[] = '<a ' . $title . 'href="' . get_pagenum_link($cnt) . 
				'"  >'. $cnt . '</a>' . $end_link;
			}
		}
		
		echo join($seperator, $x);

		echo $before_next;
		
		if( $current_page == $max_num_pages){
			if(get_option('SEOPager_nextallow') == 'allow'){
				echo '<span class="current"' .'" > ' . $nxtlabel . '</span>';
			}
		} else{
			$title = 'title="' .($current_page+1) . '"';			
			echo '<a ' . $title .  ' href="' . 
			get_pagenum_link(($current_page + 1))  .'" > ' . $nxtlabel . '</a>';
		}
		echo '</div>';
	}	
}


function kanso_sd_get_begin_and_end($page_number, $total_pages, $auto_center_minimum = 0, 
$max_listed_pages = 10, $number_of_pages_at_begin =2 , $number_of_pages_at_end = 2)
{

	if($auto_center_minimum == 0) {
		$auto_center_minimum = $max_listed_pages -1;
	}

	if (!$page_number) {
		$page_number = 1;	
	}

	$half_max = $max_listed_pages/2;
	
	if($auto_center_minimum >= $page_number ){
		//pager centers at half_max
		$start = floor($page_number / ($max_listed_pages)) * $max_listed_pages; 
	} else {
		//pager centers at selected page
		$start = floor($page_number -$half_max) + 1 ;
	}
	
	// if max listed pages < pages at begin adjust start
	if($max_listed_pages <= $number_of_pages_at_begin 
	&& $start <= $number_of_pages_at_begin  ){
		if($page_number == $max_listed_pages 
		|| ($page_number == $max_listed_pages + 1)){
			$start = floor($page_number -$half_max) + 1 ;
		}
	}
	
	// if max listed pages >= pages at begin adjust start
	if($max_listed_pages >= $number_of_pages_at_begin 
	&& $start >= $number_of_pages_at_begin 
	&& $page_number -1<= $max_listed_pages)
	{
		if($page_number == $max_listed_pages 
		|| ($page_number == $max_listed_pages + 1)){
			$start = floor($page_number -$half_max) + 1 ;
		}
	}
	
	// if page number is close to end add start to keep max_listed_pages # of pages
	if(($page_number + $half_max) > $total_pages 
	&& $page_number + 1 > $max_listed_pages){
		$pages_left = $total_pages - $page_number;
		$start -= floor($half_max  - $pages_left);
	}
	
	if (!$start || $start < 0) {
		$start = 1;	
	}
	
	$end = ($total_pages < ($start + $max_listed_pages - 1)) 
	? $total_pages : $start + $max_listed_pages - 1;
	
	if($end + $number_of_pages_at_end >= $total_pages ){
		$end = $total_pages;
	}
	
	if($total_pages <= ($number_of_pages_at_end + $number_of_pages_at_begin 
	+ $max_listed_pages)){
		$start = 1;
		$end = $total_pages;
	}
	return array($start,$end);
}


?>